package edu.kit.ipd.descartes.adaptation.evaluation.weightingfunction;

import edu.kit.ipd.descartes.mm.adaptation.Tactic;
import edu.kit.ipd.descartes.mm.adaptation.WeightedTactic;

public interface IWeightingFunctionCalculator {
	
	/**
	 * Calculates the new weight of the given {@link Tactic}.
	 * 
	 * @param impact
	 * @return
	 */
	double calculateWeight(WeightedTactic weightedTactic);
	
	/**
	 * Calculates and sets the new weight of the given {@link WeightedTactic}.
	 * 
	 * @param impact
	 * @return
	 */
	void updateWeight(WeightedTactic weightedTactic);

}
