package edu.kit.ipd.descartes.adaptation.model.perfdatarepo;

import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.emf.ecore.xmi.impl.XMIResourceFactoryImpl;

import edu.kit.ipd.descartes.adaptation.model.AbstractEcoreModelLoader;
import edu.kit.ipd.descartes.perfdatarepo.PerfdatarepoPackage;
import edu.kit.ipd.descartes.perfdatarepo.PerformanceDataRepository;

public class PerformanceDataRepositoryModelLoader extends AbstractEcoreModelLoader {

    public static final EPackage[] PERF_DATA_REPO_EPACKAGES = new EPackage[] { PerfdatarepoPackage.eINSTANCE };

    private static PerformanceDataRepositoryModelLoader instance = null;

    public static PerformanceDataRepositoryModelLoader getInstance() {
        if (instance == null) {
            instance = new PerformanceDataRepositoryModelLoader();
        }
        return instance;
    }

    public PerformanceDataRepositoryModelLoader() {
        initializeResourceSet(new ResourceSetImpl());
    }

    @Override
    public void initializeResourceSet(ResourceSet resourceSet) {
        setResourceSet(resourceSet);
        /* Register the default resource factory -- only needed for stand-alone! */
        getResourceSet().getResourceFactoryRegistry().getExtensionToFactoryMap()
                .put(Resource.Factory.Registry.DEFAULT_EXTENSION, new XMIResourceFactoryImpl());

        /* Register also the packages needed for the DMM meta model */
        for (EPackage ePackage : PERF_DATA_REPO_EPACKAGES) {
            getResourceSet().getResourceFactoryRegistry().getExtensionToFactoryMap().put(ePackage.getNsURI(), ePackage);
        }

    }

    @Override
    public PerformanceDataRepository load(URI uri) {
        return (PerformanceDataRepository) super.load(uri);
    }
}
